/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
/*///+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
//+------------------------------------------------------------------+
//|                                                       d.mq4 |
//|                                                            Urain |
//+------------------------------------------------------------------+
#property copyright "Urain"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_level1 0.0
#property indicator_color1 Red
#property indicator_color2 Silver
//---- input parameters
extern int   period              =25;
extern int   Signalperiod        =5;      
                                 extern string \SMA\EMA\SMMA\LWMA="0 1 2 3";
extern int   ma_method           =0;
extern int   Signalma_method     =0; 
                                 extern string \CLOSE\OPEN\HIGH\LOW\MEDIAN="\TYPICAL\WEIGHTED\ 0 1 2 3 4 5 6";
extern int   applied_price       =0;
//---- buffers
double e0[],e1[];
//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int init()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
  SetIndexStyle(0,DRAW_LINE);
  SetIndexBuffer(0,e0);
  SetIndexDrawBegin(0,period+1);  
  SetIndexStyle(1,DRAW_LINE);
  SetIndexBuffer(1,e1);
  SetIndexDrawBegin(1,period+Signalperiod+1);    
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int deinit()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

int start()
{//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
 int lim;
 double IMA0,IMAp;
 int cb=IndicatorCounted(); 
 if(cb<0) return(-1);
 if(cb>0) cb--;
 lim=Bars-1-period; 
 for(int i=lim;i>0;i--)
    {IMA0=iMA(NULL,0,period,0,ma_method,applied_price,i);
     IMAp=iMA(NULL,0,period,0,ma_method,applied_price,i+1);
     e0[i]= (IMA0-IMAp)*(1.0/Point);     
    }
 for( i=lim-Signalperiod;i>0;i--)
     e1[i]=iMAOnArray( e0, 0, Signalperiod, 0, Signalma_method, i) ;
      
      
return(0);
}//+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+

/*
iMA(NULL,0,period,0,ma_method,applied_price,i)

ma_method   -    .         (Moving Average). 

MODE_SMA 0    
MODE_EMA 1    
MODE_SMMA 2    
MODE_LWMA 3 -   

applied_price   -    .      . 

PRICE_CLOSE 0   
PRICE_OPEN 1   
PRICE_HIGH 2   
PRICE_LOW 3   
PRICE_MEDIAN 4  , (high+low)/2 
PRICE_TYPICAL 5  , (high+low+close)/3 
PRICE_WEIGHTED 6   , (high+low+close+close)/4 
*/

